﻿--[[
	Simple lightweight support for other libraries and systems
]]

if KarmaAce then return; end


KarmaAce = {

}


function KarmaAce:OnPlayerLoginAce( frame, inst )
	if not LibStub then return; end

	inst._acelib = { };
	local _inst = inst._acelib;	
	_inst.name		= inst._instance.name.."Ace";
	_inst.nameDB	= inst._instance.name.."AceDB";
	_inst.L			= LibStub("AceLocale-3.0", true)	and LibStub("AceLocale-3.0"):GetLocale(inst._instance.name, false);	
	_inst.instfu	= LibStub("LibFuBarPlugin-3.0", true);
	_inst.instance	= LibStub("AceAddon-3.0", true)		and LibStub("AceAddon-3.0"):NewAddon( _inst.name, "AceConsole-3.0" );
		if _inst.instance and _inst.instfu then LibStub("AceAddon-3.0", true):EmbedLibrary(_inst.instance, "LibFuBarPlugin-3.0") end
	_inst.db		= LibStub("AceDB-3.0", true)		and LibStub("AceDB-3.0"):New( _inst.nameDB, { profile = {
		showwindows = { res = false, status = false, },
		showall		= false, quiet = false,
		rsinput		= { show = false, xOfs = 0, yOfs = 0, saved = false, },
	} } );
	_inst.menu		= _inst.L and _inst.instance and _inst.instfu and { handler = _inst.instance, type = "group", args = { 
		help	= {	type = "execute", order = 10, name = _inst.L["Help"], desc = _inst.L["Show Help"],
					passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("help") end,		},
		main	= {	type = "execute", order = 10, name = _inst.L["Main Window"], desc = _inst.L["Show Main Window"],
					passValue = _inst.instance, func = function(self) self:ExecChatCommandAce() end,			},
		options	= {	type = "execute", order = 10, name = _inst.L["Options"], desc = _inst.L["Show Options"],
					passValue = _inst.instance, func = function(self) self:ExecChatCommandAce("options") end,	},
	} }

	-- ace and related
	if _inst.instance then													-- set up options
		local aceInst = _inst.instance;		
		aceInst._karma					= inst;
		aceInst._L						= _inst.L or { };
		aceInst.db						= _inst.db;
		aceInst.title					= inst._addonmeta.title;
		aceInst.version					= inst._addonmeta.version;
		aceInst.OnUpdateFuBarTooltip	= KarmaAce.OnUpdateFuBarTooltip;	-- Mouseover menu	
		aceInst.OnFuBarClick			= KarmaAce.OnFuBarClick
		aceInst.ExecChatCommandAce		= KarmaAce.ExecChatCommandAce;
		aceInst.OnMenuRequest			= _inst.menu;
		aceInst.OnInitialize			= KarmaAce.OnInitialize;
		aceInst:SetFuBarOption("hasIcon", true)
		aceInst:SetFuBarOption("iconPath", inst._addonmeta.icon);
		aceInst:SetFuBarOption("hasNoColor", true)
		aceInst:SetFuBarOption("independentProfile", true)
		aceInst:SetFuBarOption("clickableTooltip", true)
		aceInst:SetFuBarOption("cannotDetachTooltip", true)
		aceInst:SetFuBarOption("hideWithoutStandby", true)
		aceInst:SetFuBarOption("defaultPosition", "CENTER")
		aceInst:SetFuBarOption("configType", "Dewdrop-2.0")		
--		_inst.instfu:OnEmbedInitialize(aceInst);
--		inst:DebugTable("OnPlayerLoginAce: _inst", aceInst);
	end
	
	-- ct mod and related
	if ( CT_RegisterMod ) then
		CT_RegisterMod(inst._addonmeta.title, "Display window", 5, self._addonmeta.icon,
			self._addonmeta.desc, "switch", self, function(self) self:ExecChatCommandAce() end );
	end

end


function KarmaAce:OnUpdateFuBarTooltip()
	GameTooltip:AddLine(self._karma._instance.name);
	GameTooltip:AddLine(" ");
	if self.OnUpdateFuBarTooltipCustom then self:OnUpdateFuBarTooltipCustom(); end
	GameTooltip:AddLine(self._L["SHOW_TOOLTIP_FU"], 0.2, 1, 0.2, 1);
end


function KarmaAce:OnFuBarClick(button)
	self:ExecChatCommandAce( IsShiftKeyDown() and "options" )
end


function KarmaAce:ExecChatCommandAce( command )
	local cmd = (command and " "..command) or "";
	self._karma:ExecuteChatCommand( "/"..self._karma._instance.name..cmd );
end


function KarmaAce:OnInitialize( )
	local _inst = self._karma._acelib;
	if ( _inst.menu ) then
		for i, v in pairs (_inst.menuopt.args) do
			_inst.menu.args[i] = v;
		end
		self._karma:ArgsToTable(_inst.menu.args, _inst.instfu:GetEmbedRockConfigOptions(_inst.instance));
		for i, v in pairs (_inst.menu.args) do
			if v.type == "boolean" then v.type = "toggle" end
			if v.type == "choice" then v.type = "text" end
			if v.choices then v.validate = v.choices end
			if i == "hide" then v.name = "Hide" end
		end
	end
end
